
# 內容優先朗讀NVDA插件

讓純文本內容在控件信息之前朗讀，提供更好的閱讀體驗。完全依賴NVDA本地化API，支援所有語言。

## 下載

* 你可以
[點擊這裡下載最新版本](https://github.com/c469591/ContentPriorityReading/raw/main/content_priority_reading%20V0.2.nvda-addon)
的NVDA插件。
* 你還可以前往我的github倉庫頁面
[點我前往內容優先朗讀的github倉庫頁面](https://github.com/c469591/ContentPriorityReading)

### 相容性

NVDA2024.1上測試正常

## 🚀 功能特色

* 智能語音重排：自動將文本內容排在控件類型信息之前
* 多語言支援：純API實現，支援所有NVDA支援的語言
* 實時切換：一鍵開啟/關閉功能
* 調試模式：開發者友好的詳細日誌輸出
* 診斷工具：內建多種診斷和測試功能

## ⌨️ 快捷鍵

### 預設快捷鍵

* NVDA+Ctrl+Shift+Y：切換內容優先朗讀功能開關

### 可自定義快捷鍵的功能

以下功能可透過 NVDA 的「輸入手勢」對話框自定義快捷鍵：

* 切換調試模式：查看詳細的語音序列處理信息
* 診斷API狀態：檢查控件類型獲取情況和成功率
* 測試重排功能：演示語音重排效果
* 顯示控件類型：查看當前載入的本地化控件類型
* 重新載入類型：刷新本地化控件類型緩存
* 顯示插件狀態：查看當前設定和最後處理的序列

## 🔧 使用方法

### 基本使用

1. 按 `NVDA+Ctrl+Shift+Y` 開啟功能
1. 在網頁或應用程式中正常瀏覽
1. 注意聽取語音順序的變化：內容會優先於控件類型被朗讀

### 範例效果

開啟前：「按鈕 確定」  
開啟後：「確定 按鈕」

開啟前：「連結 首頁」  
開啟後：「首頁 連結」

## 🛠️ 故障排除

### 當發現沒有按照預期改變順序時

如果你發現某些情況下插件沒有正常工作，可以按照以下步驟收集診斷信息：

#### 1. 開啟調試模式

1. 開啟NVDA功能表 → 偏好設定 → 輸入手勢
1. 在「內容優先朗讀」分類下找到「切換調試模式」
1. 為其設定一個快捷鍵（例如：NVDA+Ctrl+Shift+D）
1. 按下設定的快捷鍵開啟調試模式
1. 確認聽到「調試模式已開啟」的提示

#### 2. 重現問題操作

1. 按照平常的方式瀏覽網頁或使用軟體
1. 嘗試在有問題的頁面或控件上重現語音順序問題
1. 多測試幾個不同的控件類型（按鈕、連結、文字框等）

#### 3. 複製日誌資訊

1. 開啟NVDA功能表 → 工具 → 檢視事件記錄
1. 在日誌視窗中按 `Ctrl+A` 全選所有內容
1. 按 `Ctrl+C` 複製日誌內容
1. 將複製的日誌內容貼到文字檔或電子郵件中發給我，電子郵件→
c469591@mail.batol.net

#### 4. 關閉調試模式並連繫開發者

完成問題重現後，記得按同樣的快捷鍵關閉調試模式，避免產生過多日誌資訊。


## 更新日誌

* v0.2 修復跟其他需要補貨朗讀內容的插件衝突的問題
